Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj/nicholas.pbxuser
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj/nicholas.pbxuser	(revision 424)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj/nicholas.pbxuser	(revision 425)
@@ -2337,4 +4473,388 @@
 		};
 	};
+	E183EA820D78E48700D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC3D04959F5A00AEFBF9 /* ICeCoffEEServicePrefController.m */;
+		name = "ICeCoffEEServicePrefController.m: 90";
+		rLen = 0;
+		rLoc = 3621;
+		rType = 0;
+		vrLen = 3261;
+		vrLoc = 1083;
+	};
+	E183EA970D78E70200D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC4504959F5A00AEFBF9 /* ICeCoffEEKeyEquivalents.m */;
+		rLen = 7;
+		rLoc = 6575;
+		rType = 0;
+	};
+	E183EA9C0D78E73100D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC3D04959F5A00AEFBF9 /* ICeCoffEEServicePrefController.m */;
+		name = "ICeCoffEEServicePrefController.m: 399";
+		rLen = 15;
+		rLoc = 15761;
+		rType = 0;
+		vrLen = 747;
+		vrLoc = 15273;
+	};
+	E183EA9D0D78E73100D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC3D04959F5A00AEFBF9 /* ICeCoffEEServicePrefController.m */;
+		name = "ICeCoffEEServicePrefController.m: 399";
+		rLen = 15;
+		rLoc = 15761;
+		rType = 0;
+		vrLen = 747;
+		vrLoc = 15273;
+	};
+	E183EA9E0D78E73100D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC4504959F5A00AEFBF9 /* ICeCoffEEKeyEquivalents.m */;
+		name = "ICeCoffEEKeyEquivalents.m: 136";
+		rLen = 7;
+		rLoc = 6575;
+		rType = 0;
+		vrLen = 1566;
+		vrLoc = 5221;
+	};
+	E183EAB00D78E87700D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		comments = "error: cannot find interface declaration for ‘NSTextFieldCell’, superclass of ‘ICeCoffEELabeledIconCell’";
+		fRef = E1FC8F260C1A3C530021AB09 /* ICeCoffEELabeledIconCell.h */;
+		rLen = 1;
+		rLoc = 11;
+		rType = 1;
+	};
+	E183EAB50D78E88A00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E1FC8F270C1A3C530021AB09 /* ICeCoffEELabeledIconCell.m */;
+		name = "ICeCoffEELabeledIconCell.m: 58";
+		rLen = 0;
+		rLoc = 1288;
+		rType = 0;
+		vrLen = 2675;
+		vrLoc = 873;
+	};
+	E183EAB60D78E88A00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E1FC8F270C1A3C530021AB09 /* ICeCoffEELabeledIconCell.m */;
+		name = "ICeCoffEELabeledIconCell.m: 58";
+		rLen = 0;
+		rLoc = 1288;
+		rType = 0;
+		vrLen = 2681;
+		vrLoc = 873;
+	};
+	E183EAB70D78E88A00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E1FC8F260C1A3C530021AB09 /* ICeCoffEELabeledIconCell.h */;
+		name = "ICeCoffEELabeledIconCell.h: 1";
+		rLen = 0;
+		rLoc = 0;
+		rType = 0;
+		vrLen = 460;
+		vrLoc = 0;
+	};
+	E183EAB80D78E88A00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E1FC8F270C1A3C530021AB09 /* ICeCoffEELabeledIconCell.m */;
+		name = "ICeCoffEELabeledIconCell.m: 58";
+		rLen = 0;
+		rLoc = 1288;
+		rType = 0;
+		vrLen = 2675;
+		vrLoc = 873;
+	};
+	E183EAB90D78E88A00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E1FC8F260C1A3C530021AB09 /* ICeCoffEELabeledIconCell.h */;
+		name = "ICeCoffEELabeledIconCell.h: 13";
+		rLen = 0;
+		rLoc = 294;
+		rType = 0;
+		vrLen = 436;
+		vrLoc = 0;
+	};
+	E183EABA0D78E88A00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E1FC8F270C1A3C530021AB09 /* ICeCoffEELabeledIconCell.m */;
+		name = "ICeCoffEELabeledIconCell.m: 58";
+		rLen = 0;
+		rLoc = 1288;
+		rType = 0;
+		vrLen = 2675;
+		vrLoc = 873;
+	};
+	E183EABB0D78E88A00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E1FC8F260C1A3C530021AB09 /* ICeCoffEELabeledIconCell.h */;
+		name = "ICeCoffEELabeledIconCell.h: 9";
+		rLen = 52;
+		rLoc = 152;
+		rType = 0;
+		vrLen = 460;
+		vrLoc = 0;
+	};
+	E183EABE0D78E88A00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E183EABF0D78E88A00D04D3E /* NSTextFieldCell.h */;
+		rLen = 1;
+		rLoc = 41;
+		rType = 1;
+	};
+	E183EABF0D78E88A00D04D3E /* NSTextFieldCell.h */ = {
+		isa = PBXFileReference;
+		lastKnownFileType = sourcecode.c.h;
+		name = NSTextFieldCell.h;
+		path = /Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks/AppKit.framework/Versions/C/Headers/NSTextFieldCell.h;
+		sourceTree = "<absolute>";
+		uiCtxt = {
+			sepNavIntBoundsRect = "{{0, 0}, {903, 932}}";
+			sepNavSelRange = "{362, 12}";
+			sepNavVisRange = "{0, 1569}";
+			sepNavWindowFrame = "{{84, 142}, {962, 968}}";
+		};
+	};
+	E183EAC00D78E88A00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E183EAC10D78E88A00D04D3E /* NSTextFieldCell.h */;
+		name = "NSTextFieldCell.h: 19";
+		rLen = 12;
+		rLoc = 362;
+		rType = 0;
+		vrLen = 1569;
+		vrLoc = 0;
+	};
+	E183EAC10D78E88A00D04D3E /* NSTextFieldCell.h */ = {
+		isa = PBXFileReference;
+		lastKnownFileType = sourcecode.c.h;
+		name = NSTextFieldCell.h;
+		path = /Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks/AppKit.framework/Versions/C/Headers/NSTextFieldCell.h;
+		sourceTree = "<absolute>";
+	};
+	E183EAC40D78E88A00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E183EAC50D78E88A00D04D3E /* NSColor.h */;
+		rLen = 1;
+		rLoc = 103;
+		rType = 1;
+	};
+	E183EAC50D78E88A00D04D3E /* NSColor.h */ = {
+		isa = PBXFileReference;
+		lastKnownFileType = sourcecode.c.h;
+		name = NSColor.h;
+		path = /Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks/AppKit.framework/Versions/C/Headers/NSColor.h;
+		sourceTree = "<absolute>";
+	};
+	E183EAC60D78E88A00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E183EAC70D78E88A00D04D3E /* NSColor.h */;
+		name = "NSColor.h: 98";
+		rLen = 16;
+		rLoc = 5584;
+		rType = 0;
+		vrLen = 4443;
+		vrLoc = 3825;
+	};
+	E183EAC70D78E88A00D04D3E /* NSColor.h */ = {
+		isa = PBXFileReference;
+		lastKnownFileType = sourcecode.c.h;
+		name = NSColor.h;
+		path = /Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks/AppKit.framework/Versions/C/Headers/NSColor.h;
+		sourceTree = "<absolute>";
+		uiCtxt = {
+			sepNavIntBoundsRect = "{{0, 0}, {903, 3300}}";
+			sepNavSelRange = "{5584, 16}";
+			sepNavVisRange = "{3822, 4470}";
+			sepNavWindowFrame = "{{61, 163}, {962, 968}}";
+		};
+	};
+	E183EACA0D78E88A00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC4504959F5A00AEFBF9 /* ICeCoffEEKeyEquivalents.m */;
+		name = "ICeCoffEEKeyEquivalents.m: 136";
+		rLen = 7;
+		rLoc = 6575;
+		rType = 0;
+		vrLen = 4500;
+		vrLoc = 2244;
+	};
+	E183EACE0D78E93300D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC4504959F5A00AEFBF9 /* ICeCoffEEKeyEquivalents.m */;
+		name = "ICeCoffEEKeyEquivalents.m: 136";
+		rLen = 7;
+		rLoc = 6575;
+		rType = 0;
+		vrLen = 1523;
+		vrLoc = 5221;
+	};
+	E183EAD60D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC3E04959F5A00AEFBF9 /* ICeCoffEEServicePrefController.h */;
+		name = "ICeCoffEEServicePrefController.h: 1";
+		rLen = 0;
+		rLoc = 0;
+		rType = 0;
+		vrLen = 559;
+		vrLoc = 0;
+	};
+	E183EAD70D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC3D04959F5A00AEFBF9 /* ICeCoffEEServicePrefController.m */;
+		name = "ICeCoffEEServicePrefController.m: 339";
+		rLen = 25;
+		rLoc = 12942;
+		rType = 0;
+		vrLen = 3683;
+		vrLoc = 11679;
+	};
+	E183EAD80D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC3D04959F5A00AEFBF9 /* ICeCoffEEServicePrefController.m */;
+		name = "ICeCoffEEServicePrefController.m: 339";
+		rLen = 25;
+		rLoc = 12942;
+		rType = 0;
+		vrLen = 3683;
+		vrLoc = 11679;
+	};
+	E183EAD90D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC3E04959F5A00AEFBF9 /* ICeCoffEEServicePrefController.h */;
+		name = "ICeCoffEEServicePrefController.h: 1";
+		rLen = 0;
+		rLoc = 0;
+		rType = 0;
+		vrLen = 559;
+		vrLoc = 0;
+	};
+	E183EADA0D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC3D04959F5A00AEFBF9 /* ICeCoffEEServicePrefController.m */;
+		name = "ICeCoffEEServicePrefController.m: 360";
+		rLen = 0;
+		rLoc = 14293;
+		rType = 0;
+		vrLen = 3689;
+		vrLoc = 11679;
+	};
+	E183EADD0D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E183EADE0D78EA8F00D04D3E /* NSTableColumn.h */;
+		rLen = 1;
+		rLoc = 14;
+		rType = 1;
+	};
+	E183EADE0D78EA8F00D04D3E /* NSTableColumn.h */ = {
+		isa = PBXFileReference;
+		lastKnownFileType = sourcecode.c.h;
+		name = NSTableColumn.h;
+		path = /Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks/AppKit.framework/Versions/C/Headers/NSTableColumn.h;
+		sourceTree = "<absolute>";
+	};
+	E183EADF0D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E183EAE00D78EA8F00D04D3E /* NSTableColumn.h */;
+		name = "NSTableColumn.h: 50";
+		rLen = 4;
+		rLoc = 1272;
+		rType = 0;
+		vrLen = 2981;
+		vrLoc = 222;
+	};
+	E183EAE00D78EA8F00D04D3E /* NSTableColumn.h */ = {
+		isa = PBXFileReference;
+		lastKnownFileType = sourcecode.c.h;
+		name = NSTableColumn.h;
+		path = /Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks/AppKit.framework/Versions/C/Headers/NSTableColumn.h;
+		sourceTree = "<absolute>";
+	};
+	E183EAE30D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E183EAE40D78EA8F00D04D3E /* NSOutlineView.h */;
+		rLen = 1;
+		rLoc = 150;
+		rType = 1;
+	};
+	E183EAE40D78EA8F00D04D3E /* NSOutlineView.h */ = {
+		isa = PBXFileReference;
+		lastKnownFileType = sourcecode.c.h;
+		name = NSOutlineView.h;
+		path = /Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks/AppKit.framework/Versions/C/Headers/NSOutlineView.h;
+		sourceTree = "<absolute>";
+		uiCtxt = {
+			sepNavIntBoundsRect = "{{0, 0}, {903, 3135}}";
+			sepNavSelRange = "{11545, 6}";
+			sepNavVisRange = "{8247, 5019}";
+			sepNavWindowFrame = "{{199, 37}, {962, 968}}";
+		};
+	};
+	E183EAE50D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E183EAE60D78EA8F00D04D3E /* NSOutlineView.h */;
+		name = "NSOutlineView.h: 151";
+		rLen = 13;
+		rLoc = 6134;
+		rType = 0;
+		vrLen = 3837;
+		vrLoc = 3861;
+	};
+	E183EAE60D78EA8F00D04D3E /* NSOutlineView.h */ = {
+		isa = PBXFileReference;
+		lastKnownFileType = sourcecode.c.h;
+		name = NSOutlineView.h;
+		path = /Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks/AppKit.framework/Versions/C/Headers/NSOutlineView.h;
+		sourceTree = "<absolute>";
+	};
+	E183EAE70D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC4504959F5A00AEFBF9 /* ICeCoffEEKeyEquivalents.m */;
+		rLen = 1;
+		rLoc = 111;
+		rType = 1;
+	};
+	E183EAE80D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E12FEC4504959F5A00AEFBF9 /* ICeCoffEEKeyEquivalents.m */;
+		name = "ICeCoffEEKeyEquivalents.m: 112";
+		rLen = 134;
+		rLoc = 4821;
+		rType = 0;
+		vrLen = 4500;
+		vrLoc = 2244;
+	};
+	E183EAE90D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E183EAC10D78E88A00D04D3E /* NSTextFieldCell.h */;
+		name = "NSTextFieldCell.h: 19";
+		rLen = 12;
+		rLoc = 362;
+		rType = 0;
+		vrLen = 1569;
+		vrLoc = 0;
+	};
+	E183EAEA0D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E1FC8F260C1A3C530021AB09 /* ICeCoffEELabeledIconCell.h */;
+		name = "ICeCoffEELabeledIconCell.h: 9";
+		rLen = 52;
+		rLoc = 152;
+		rType = 0;
+		vrLen = 460;
+		vrLoc = 0;
+	};
+	E183EAEB0D78EA8F00D04D3E /* PBXTextBookmark */ = {
+		isa = PBXTextBookmark;
+		fRef = E183EAC70D78E88A00D04D3E /* NSColor.h */;
+		name = "NSColor.h: 98";
+		rLen = 16;
+		rLoc = 5584;
+		rType = 0;
+		vrLen = 4443;
+		vrLoc = 3825;
+	};
 	E191FC9C0831B8FB003B09BC /* ICeCoffEEServices.h */ = {
 		uiCtxt = {
@@ -2359,5 +4879,5 @@
 		name = "ICeCoffEEServicePrefController.m: 92";
 		rLen = 0;
-		rLoc = 3320;
+		rLoc = 3665;
 		rType = 0;
 		vrLen = 3172;
@@ -2433,5 +4953,5 @@
 		name = "ICeCoffEEServicePrefController.m: 92";
 		rLen = 0;
-		rLoc = 3320;
+		rLoc = 3665;
 		rType = 0;
 		vrLen = 3172;
@@ -2665,14 +5185,16 @@
 	E1FC8F260C1A3C530021AB09 /* ICeCoffEELabeledIconCell.h */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {802, 930}}";
-			sepNavSelRange = "{395, 0}";
+			sepNavIntBoundsRect = "{{0, 0}, {782, 931}}";
+			sepNavSelRange = "{152, 52}";
+			sepNavVisRange = "{0, 460}";
 			sepNavVisRect = "{{0, 0}, {802, 929}}";
+			sepNavWindowFrame = "{{756, 61}, {841, 967}}";
 		};
 	};
 	E1FC8F270C1A3C530021AB09 /* ICeCoffEELabeledIconCell.m */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {787, 1221}}";
-			sepNavSelRange = "{3335, 3}";
-			sepNavVisRange = "{2915, 793}";
+			sepNavIntBoundsRect = "{{0, 0}, {782, 1364}}";
+			sepNavSelRange = "{1171, 0}";
+			sepNavVisRange = "{0, 2164}";
 			sepNavVisRect = "{{0, 0}, {802, 929}}";
 			sepNavWindowFrame = "{{756, 61}, {841, 967}}";
@@ -2690,7 +5212,7 @@
 	F56276C20379923401AA4DA5 /* English */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {715, 6618}}";
-			sepNavSelRange = "{8076, 0}";
-			sepNavVisRect = "{{0, 2498}, {715, 709}}";
+			sepNavIntBoundsRect = "{{0, 0}, {715, 6635}}";
+			sepNavSelRange = "{852, 0}";
+			sepNavVisRect = "{{0, 5925}, {715, 709}}";
 			sepNavWindowFrame = "{{1052, 142}, {754, 746}}";
 		};
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEInvertingTextFieldCell.h
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEInvertingTextFieldCell.h	(revision 425)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEInvertingTextFieldCell.h	(revision 425)
@@ -0,0 +1,16 @@
+//
+//  ICeCoffEEInvertingTextFieldCell.h
+//  ICeCoffEE
+//
+//  Created by Nicholas Riley on 2/29/08.
+//  Copyright 2008 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface ICeCoffEEInvertingTextFieldCell : NSTextFieldCell {
+
+}
+
+@end
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEInvertingTextFieldCell.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEInvertingTextFieldCell.m	(revision 425)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEInvertingTextFieldCell.m	(revision 425)
@@ -0,0 +1,33 @@
+//
+//  ICeCoffEEInvertingTextFieldCell.m
+//  ICeCoffEE
+//
+//  Created by Nicholas Riley on 2/29/08.
+//  Copyright 2008 Nicholas Riley. All rights reserved.
+//
+
+#import "ICeCoffEEInvertingTextFieldCell.h"
+
+
+@implementation ICeCoffEEInvertingTextFieldCell
+
+- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView;
+{
+    if ([self isHighlighted]) {
+	NSMutableAttributedString *astr = [[self attributedStringValue] mutableCopy];
+	unsigned location = 0, length = [astr length];
+	NSRange range;
+	while (location < length) {
+	    if ([astr attribute: NSForegroundColorAttributeName atIndex: location effectiveRange: &range] == nil) {
+		[astr addAttribute: NSForegroundColorAttributeName value: [NSColor whiteColor]
+			     range: range];
+	    }
+	    location += range.length;
+	}
+	[self setAttributedStringValue: astr];
+	[astr release];
+    }
+    [super drawWithFrame: cellFrame inView: controlView];
+}
+
+@end
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.m	(revision 424)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.m	(revision 425)
@@ -11,10 +11,14 @@
 #import "ICeCoffEEServicePrefController.h"
 #import "ICeCoffEENonHighlightingButtonCell.h"
-#import "ICeCoffEENonHighlightingTextFieldCell.h"
+#import "ICeCoffEEInvertingTextFieldCell.h"
 #import "ICeCoffEELabeledIconCell.h"
 #import <objc/objc.h>
 #import <ApplicationEnhancer/ApplicationEnhancer.h>
 
-static NSNumber *ICCF_SERVICE_SHOWN, *ICCF_SERVICE_HIDDEN, *ICCF_SERVICE_MIXED;
+const int ICCF_SERVICE_UNKNOWN = 0;
+const int ICCF_SERVICE_SHOWN = 1;
+const int ICCF_SERVICE_HIDDEN = 2;
+const int ICCF_SERVICE_MIXED = 3;
+
 static NSDictionary *ICCF_SERVICE_OPTION_HIDDEN;
 
@@ -61,18 +65,31 @@
 }
 
-static inline void ICCF_UpdateKeyEquivalentForItem(NSMenuItem *item, id state) {
-    NSNumber *oldState = [item representedObject];
-    if ((oldState == nil || oldState == ICCF_SERVICE_SHOWN) && state == ICCF_SERVICE_HIDDEN)
+static int ICCF_GetServiceState(NSMenuItem *item) {
+    return [item tag];
+}
+
+static void ICCF_SetServiceState(NSMenuItem *item, int state) {
+    [item setTag: state];
+}
+
+static inline void ICCF_UpdateKeyEquivalentForItem(NSMenuItem *item, int state) {
+    int oldState = ICCF_GetServiceState(item);
+    if ((oldState == ICCF_SERVICE_UNKNOWN || oldState == ICCF_SERVICE_SHOWN) && state == ICCF_SERVICE_HIDDEN)
 	ICCF_RemoveKeyEquivalentForItem(item);
-    else if (oldState == ICCF_SERVICE_HIDDEN && (state == ICCF_SERVICE_SHOWN || state == nil))
+    else if (oldState == ICCF_SERVICE_HIDDEN && (state == ICCF_SERVICE_SHOWN || state == ICCF_SERVICE_UNKNOWN))
 	ICCF_AddKeyEquivalentForItem(item);
 }
 
+
 static inline NSCellStateValue ICCF_ServiceItemState(NSMenuItem *item) {
-    id state = [item representedObject];
-    return (state == nil) ? NSOnState : [state intValue];
-}
-
-static void ICCF_PropagateServiceStateChange(NSMenu *menu, id state) {
+    int state = ICCF_GetServiceState(item);
+    if (state == ICCF_SERVICE_HIDDEN)
+	return NSOffState;
+    if (state == ICCF_SERVICE_MIXED)
+	    return NSMixedState;
+    return NSOnState;
+}
+
+static void ICCF_PropagateServiceStateChange(NSMenu *menu, int state) {
     NSEnumerator *e = [[menu itemArray] objectEnumerator];
     NSMenuItem *item;
@@ -86,5 +103,5 @@
 	    ICCF_UpdateKeyEquivalentForItem(item, state);
 	
-	[item setRepresentedObject: state];
+	ICCF_SetServiceState(item, state);
     }
 }
@@ -94,5 +111,5 @@
     if (submenu == nil) return ICCF_ServiceItemState(item);
 
-    if (item == changedItem) ICCF_PropagateServiceStateChange(submenu, [item representedObject]);
+    if (item == changedItem) ICCF_PropagateServiceStateChange(submenu, [item tag]);
 
     BOOL areOn = NO, areOff = NO;
@@ -108,12 +125,12 @@
                 break;
         }
-        [item setRepresentedObject: ICCF_SERVICE_MIXED];
+	ICCF_SetServiceState(item, ICCF_SERVICE_MIXED);
         return NSMixedState;
     }
     if (areOn) {
-        [item setRepresentedObject: ICCF_SERVICE_SHOWN];
+	ICCF_SetServiceState(item, ICCF_SERVICE_SHOWN);
         return NSOnState;
     } else {
-        [item setRepresentedObject: ICCF_SERVICE_HIDDEN];
+	ICCF_SetServiceState(item, ICCF_SERVICE_HIDDEN);
         return NSOffState;
     }
@@ -159,5 +176,5 @@
         subDict = [dict objectForKey: itemTitle];
         if ([[subDict objectForKey: (NSString *)kICServiceHidden] boolValue]) {
-            [item setRepresentedObject: ICCF_SERVICE_HIDDEN];
+	    ICCF_SetServiceState(item, ICCF_SERVICE_HIDDEN);
 	    ICCF_RemoveKeyEquivalentForItem(item);
         }
@@ -214,7 +231,4 @@
 + (void)initialize;
 {
-    ICCF_SERVICE_SHOWN = [[NSNumber alloc] initWithInt: NSOnState];
-    ICCF_SERVICE_HIDDEN = [[NSNumber alloc] initWithInt: NSOffState];
-    ICCF_SERVICE_MIXED = [[NSNumber alloc] initWithInt: NSMixedState];
     ICCF_SERVICE_OPTION_HIDDEN = [[NSDictionary alloc] initWithObjectsAndKeys: [NSNumber numberWithBool: YES], kICServiceHidden, nil];
 }
@@ -239,7 +253,9 @@
 	[[serviceOutline tableColumnWithIdentifier: @"service"] setDataCell:
 	    [ICeCoffEELabeledIconCell copyFromTextFieldCell: textFieldCell]];
-
+	
         textFieldCell = [[serviceOutline tableColumnWithIdentifier: @"key"] dataCell];
-        ((struct objc_object *)textFieldCell)->isa = [ICeCoffEENonHighlightingTextFieldCell class];
+        ((struct objc_object *)textFieldCell)->isa = [ICeCoffEEInvertingTextFieldCell class];
+	
+	[serviceOutline noteNumberOfRowsChanged]; // or we get no active scroll bar or initial selection
 
         [window setResizeIncrements: NSMakeSize(1, ICCF_TableViewCellHeight(serviceOutline))];
@@ -351,9 +367,9 @@
         return [[[NSAttributedString alloc] initWithString: [item title] attributes: attrDict] autorelease];
     } else if ([[tableColumn identifier] isEqualToString: @"show"]) {
-        id state = [item representedObject];
-        if ([item submenu] != nil && state == nil) {
+        int state = ICCF_GetServiceState(item);
+        if ([item submenu] != nil && state == ICCF_SERVICE_UNKNOWN) {
             return [NSNumber numberWithInt: ICCF_PropagateServiceState(item, nil)];
         }
-        return (state == nil) ? ICCF_SERVICE_SHOWN : state;
+        return [NSNumber numberWithInt: ICCF_ServiceItemState(item)];
     } else if ([[tableColumn identifier] isEqualToString: @"key"]) {
         NSString *equivalent = [item toolTip];
@@ -368,7 +384,7 @@
 {
     if ([[tableColumn identifier] isEqualToString: @"show"]) {
-	NSNumber *newState = [object boolValue] ? nil : ICCF_SERVICE_HIDDEN;
+	int newState = [object boolValue] ? ICCF_SERVICE_SHOWN : ICCF_SERVICE_HIDDEN;
 	ICCF_UpdateKeyEquivalentForItem(item, newState);
-        [item setRepresentedObject: newState];
+	ICCF_SetServiceState(item, newState);
         
         NSMenu *submenu = [item menu];
Index: /trunk/ICeCoffEE/ICeCoffEE/Installer components/ui/ui.plist
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/Installer components/ui/ui.plist	(revision 424)
+++ /trunk/ICeCoffEE/ICeCoffEE/Installer components/ui/ui.plist	(revision 425)
@@ -23,7 +23,7 @@
 	<string>YES</string>
 	<key>MinimalAllowedSystemVersion</key>
-	<integer>4160</integer>
+	<integer>4176</integer>
 	<key>MinimalAllowedSystemVersionString</key>
-	<string>10.4</string>
+	<string>10.5</string>
 	<key>PreInstallKillProcesses</key>
 	<array>
@@ -39,9 +39,9 @@
 	<string>ICeCoffEE</string>
 	<key>ProductNumVersion</key>
-	<integer>22028291</integer>
+	<integer>-1</integer>
 	<key>ProductType</key>
 	<string>Preference Pane</string>
 	<key>ProductVersion</key>
-	<string>1.5d3</string>
+	<string></string>
 	<key>UIPlugin</key>
 	<string>UI_SCRInstall.plugin</string>
Index: /trunk/ICeCoffEE/ICeCoffEE/VERSION.xcconfig
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/VERSION.xcconfig	(revision 424)
+++ /trunk/ICeCoffEE/ICeCoffEE/VERSION.xcconfig	(revision 425)
@@ -1,1 +1,1 @@
-CURRENT_MARKETING_VERSION=1.5d3
+CURRENT_MARKETING_VERSION=1.5b1
